{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": [],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "andra28/torso-preprocessor"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#preprocess.cwl/input-file"
                }
            ],
            "id": "#preprocess.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "pakf.dat"
                    },
                    "id": "#preprocess.cwl/dat"
                }
            ]
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "andra28/torso-solver"
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#solver.cwl/dat"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.unv"
                    },
                    "id": "#solver.cwl/unv"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.UNV",
                        "outputEval": "${ self.forEach(out => out.basename = out.basename.split(\".\")[0]+\".unv\"); return self;}"
                    },
                    "id": "#solver.cwl/unvs"
                },
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.vtk"
                    },
                    "id": "#solver.cwl/vtk"
                }
            ],
            "id": "#solver.cwl"
        },
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/input-file"
                }
            ],
            "outputs": [
                {
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputSource": "#main/pak/vtk",
                    "id": "#main/vtk"
                }
            ],
            "steps": [
                {
                    "run": "#solver.cwl",
                    "in": [
                        {
                            "source": "#main/preprocess/dat",
                            "id": "#main/pak/dat"
                        }
                    ],
                    "out": [
                        "#main/pak/vtk"
                    ],
                    "id": "#main/pak"
                },
                {
                    "run": "#preprocess.cwl",
                    "in": [
                        {
                            "source": "#main/input-file",
                            "id": "#main/preprocess/input-file"
                        }
                    ],
                    "out": [
                        "#main/preprocess/dat"
                    ],
                    "id": "#main/preprocess"
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
